Prime path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题目大意:给两个4位的素数,对第一个素数变换使其变成第二个素数,其中每次只能改变一位数,并且改变之后的数也是素数,求最小改变次数

思路分析:一道搜索题。。。。可用bfs,把每次变换得到的素数放进队列中,每次判断是否可以更新最小值

#include<iostream>
#include<queue>
#include<string.h>
#include<stdio.h>
using namespace std;
bool prime(int a){
     int i;
     for(i=2;i*i<=a;i++) if(a%i==0) return false;
     return true;
}
int f(int*A){    //将数组储存的4位数转换为int整数
    int sum;
    sum=A[1]*1000+A[2]*100+A[3]*10+A[4];
    return sum;
}
queue<int>q;
int main(){
   int t,i,j,k,n,u,v,m,dp[10010],A[10];
   cin>>t;
   while(t--){
      scanf("%d%d",&n,&m);
      for(i=1000;i<=10000;i++) dp[i]=1000000;
      dp[n]=0;
      for(q.push(n);!q.empty();q.pop()){
            k=u=q.front();
            A[4]=k%10;      //转换为数组储存
            k/=10;
            A[3]= k%10;
            k/=10;
            A[2]=k%10;
            k/=10;
            A[1]=k;
            for(i=1;i<=4;i++){       //每次改变每一个数
                k=A[i];
                for(j=0;j<=9;j++){
                    if(i==1&&j==0) continue;
                    A[i]=j;
                    v=f(A);
                    if(prime(v)&&dp[v]>dp[u]+1){
                        dp[v]=dp[u]+1;
                        q.push(v);
                    }

                }
                A[i]=k;
            }
      }
      if(dp[m]!=1000000) printf("%d\n",dp[m]);
      else printf("Impossible\n");
   }
   return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值